// -*-SystemC-*-

// Copyright (C) 2008
// by all contributors.

// This file is part of SCNSL.

// SCNSL is free software:
// you can redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option)
// any later version.

// SCNSL is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with SCNSL,
// in a file named LICENSE.txt.
// If not, see <http://www.gnu.org/licenses/>.


#ifndef SCNSL__BUILTIN_PLUGIN__CORETRACINGSETUP_T_HH
#define SCNSL__BUILTIN_PLUGIN__CORETRACINGSETUP_T_HH



/// @file
/// Core tracing setup.

#include "../setup/TracingSetup_base_t.hh"

namespace Scnsl { namespace BuiltinPlugin {

    /// @brief Core tracing setup.
    class CoreTracingSetup_t:
        public Scnsl::Setup::TracingSetup_base_t
    {
    public:

        /// @brief Constructor.
        CoreTracingSetup_t()
        throw ();

        /// @brief Ddestructor.
        virtual
        ~CoreTracingSetup_t()
        throw ();


        bool print_trace_type;

    private:

        /// @brief Disabled copy constructor.
        CoreTracingSetup_t( const CoreTracingSetup_t & );

        /// @brief Disabled assignment operator.
        CoreTracingSetup_t & operator = ( const CoreTracingSetup_t & );

    };

} }



#endif

