// -*-SystemC-*-

// Copyright (C) 2008
// by all contributors..

// This file is part of SCNSL.

// SCNSL is free software:
// you can redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option)
// any later version.

// SCNSL is distributed in the hope
// that it will be useful, but WITHOUT ANY WARRANTY;
// without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.
// See the GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with SCNSL,
// in a file named LICENSE.txt.
// If not, see <http://www.gnu.org/licenses/>.



/// @file
/// A basic task interface.

#include <sstream>

#include "Task_if_t.hh"


using Scnsl::Core::Task_if_t;



// ////////////////////////////////////////////////////////////////
// Public methods.
// ////////////////////////////////////////////////////////////////


Task_if_t::~Task_if_t()
    throw ()
{
    // Nothing to do.
}

Task_if_t::task_id_t Task_if_t::getId()
    const throw ()
{
#if (SCNSL_DBG >= 5)
    std::stringstream ss;
    ss << "<> getId() " << _ID << ".";
    SCNSL_TRACE_DBG( 5, ss.str().c_str());
#endif

    return _ID;
}

Scnsl::Core::Node_t * Task_if_t::getNode()
    throw ()
{
    SCNSL_TRACE_DBG( 5, "<> getNode().");

    return _node;
}

const Scnsl::Core::Node_t * Task_if_t::getNode()
    const throw ()
{
    SCNSL_TRACE_DBG( 5, "<> getNode().");

    return _node;
}


// ////////////////////////////////////////////////////////////////
// Protected methods.
// ////////////////////////////////////////////////////////////////

Task_if_t::Task_if_t( const sc_core::sc_module_name modulename,
                      const task_id_t id,
                      Node_t * n )
    throw () :
    // Parents:
    sc_core::sc_module( modulename ),
    Scnsl::Tracing::Traceable_base_t( modulename ),
    // Members:
    _ID( id ),
    _node( n )
{
    // Nothing to do.
}
