
#ifndef SCNSL__MY_TASK_4_HH
#define SCNSL__MY_TASK_4_HH



/// @file
/// Source node.


#include <systemc>
#include <tlm.h>


// Including the library:
#include <scnsl.hh>



class MyTask4 :
    public Scnsl::Tlm::TlmTask_if_t
{

public:

    SC_HAS_PROCESS( MyTask4 );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	MyTask4( sc_core::sc_module_name name,
            const task_id_t id,
            Scnsl::Core::Node_t * n,
            const size_t proxies )
    	throw ( std::invalid_argument );

    virtual ~MyTask4() throw ();

	virtual void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

protected:

    /// @name Processes.
    //@{

    void writingProcess();

    //@}

private:

    MyTask4( MyTask4 & );

    MyTask4 & operator = ( MyTask4 & );

};

#endif

