/// @file
/// A TLM task.

#include <sstream>

#include "MyTask1.hh"



// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

MyTask1::MyTask1( sc_core::sc_module_name modulename,
                  const task_id_t id,
                  Scnsl::Core::Node_t * n,
                  const size_t proxies,
                  const int scenario )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
{

	switch ( scenario )
	{
		case 1: 	SC_THREAD( writingProcess1 );
            break;
		case 2: 	SC_THREAD( writingProcess2 );
            break;
		case 3: 	SC_THREAD( writingProcess3 );
            break;
		case 4: 	SC_THREAD( writingProcess4 );
            break;
		default:	SC_THREAD( writingProcess1 );
	}
}


MyTask1::~MyTask1() throw () {}


void MyTask1::writingProcess1()
{

	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes" << std::endl;

		TlmTask_if_t::send( tp, &i, s);
	}
}

void MyTask1::writingProcess2()
{

	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes" << std::endl;

		TlmTask_if_t::send( tp, &i, s);
	}
}

void MyTask1::writingProcess3()
{

	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes" << std::endl;

		TlmTask_if_t::send( tp, &i, s);

		wait( 28, sc_core::SC_MS );
	}
}

void MyTask1::writingProcess4()
{

	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes" << std::endl;

		TlmTask_if_t::send( tp, &i, s);

		wait( 20, sc_core::SC_MS );
		wait( 8, sc_core::SC_MS );

	}
}


void MyTask1::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t )
{
	t=t;
	char result;
	bool c;

	if(p.get_command() == Scnsl::Tlm::PACKET_COMMAND)
	{
    	result = static_cast< char >( * p.get_data_ptr() );
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data received: " << result;
		std::cout << ", packet size: " << p.get_data_length() << " bytes" << std::endl;
	}

	if(p.get_command() == Scnsl::Tlm::CARRIER_COMMAND)
	{
		c = * p.get_data_ptr();
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", carrier: " << c << std::endl;
	}
}
