

#include <sstream>
#include "MySensor_t.hh"

// ////////////////////////////////////////////////////////////////
// Constructor and destructor.
// ////////////////////////////////////////////////////////////////



struct Payload_t
{
   unsigned int id;			 
   double sender_times;         
   int Temperature;			 
};

MySensor_t::MySensor_t( const sc_core::sc_module_name modulename,
                    const task_id_t id,
                    Scnsl::Core::Node_t * n,
                    const size_t proxies )
    throw ():
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies ),
    // Fields:
    _packetArrivedEvent(), taskid()
{  

    SC_THREAD( _sender );


}


MySensor_t::~MySensor_t()
    throw ()
{
    // Nothing to do.
}

// ////////////////////////////////////////////////////////////////
// Inherited interface methods.
// ////////////////////////////////////////////////////////////////


void MySensor_t::b_transport( tlm::tlm_generic_payload & , sc_core::sc_time &  )
{
}

// ////////////////////////////////////////////////////////////////
// Processes.
// ////////////////////////////////////////////////////////////////


void MySensor_t::_sender() throw () {
    const Scnsl::Tlm::tlm_taskproxy_id_t tp = 0 ;
    Payload_t *p = static_cast<Payload_t *>(malloc(sizeof(Payload_t)*sizeof(p)));
    
    int randTemp = 0;
    while ( true ) {
        p->Temperature = (rand()%25 + 25 );
	randTemp = (rand()%50 + 50);
	wait(randTemp, sc_core::SC_MS);
        std::cout << "Sender name " << name() << " ,Temperature=" << p->Temperature << "\u2103 \t" << std::endl;;
        p->sender_times = sc_core::sc_time_stamp().to_double(); 
        TlmTask_if_t::send( tp, reinterpret_cast<byte_t *>(p), sizeof(Payload_t));  
    }
}
