 

#ifndef MyCollector_t_HH
#define MyCollector_t_HH

#include <systemc>
#include <scnsl.hh>
 
class MyCollector_t:
    public Scnsl::Tlm::TlmTask_if_t
{
public:

    SC_HAS_PROCESS( MyCollector_t );
 
    MyCollector_t( const sc_core::sc_module_name modulename,
              const task_id_t id,
              Scnsl::Core::Node_t * n,
              const size_t proxies )
    throw ();

    /// @brief Virtual destructor.
    virtual
    ~MyCollector_t()
    throw ();

    /// @name Inherited interface methods.
    //@{


    virtual
    void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

    //@}

    /// @brief Signals when a packet is arrived.
    sc_core::sc_event _packetArrivedEvent;

private:

    /// @name Processes.
    //@{

    /// @brief Sender process.
    void _sender()
        throw ();
  
    /// @brief Disabled copy constructor.
    MyCollector_t( const MyCollector_t & );

    /// @brief Disabled assignment operator.
    MyCollector_t & operator = ( MyCollector_t & );
};



#endif

